<template>
  <header>
    <section class="sticky" ref="spinner" :style="showSpinner">
      <sticky-menu spinner="spinner"></sticky-menu>
    </section>
  </header>
  <main>
    <base-section classes="section is-forground" section-color="orange">
      <Intro />
    </base-section>
    <base-section section-color="black" classes="section">
      <div class="container">
        <FixedBackground />
      </div>
    </base-section>

    <base-section
      section-color="pink"
      classes="section grid is-forground"
      :hasCheckers="true"
      :grid-top="true"
    >
      <standard> </standard>
    </base-section>

    <base-section section-color="pink" class="section is-forground">
      <image-cards></image-cards>
    </base-section>

    <base-section section-color="pink" class="section is-forground">
      <div class="container icon-cryingface">
        <kinesis-container event="scroll" tag="div">
          <kinesis-element
            :strength="cryingfaceStrength"
            :origin-y="cryingfaceOrigin"
          >
            <img :src="getImage('am-cryingface.png')" alt="Devil icon" />
          </kinesis-element>
        </kinesis-container>
      </div>
      <image-copy
        v-for="(item, i) in imageCopy"
        :key="i"
        :order="item.order"
        :position="item.position"
        :image="item.image"
        :name="item.name"
        :grid-direction="item.direction"
      >
        <template v-slot:heading>
          <h2 class="title title:main font-black" v-html="item.heading"></h2>
        </template>
        <template v-slot:copy>
          <p class="copy copy:main" v-html="item.copy"></p>
        </template>
      </image-copy>
    </base-section>

    <base-section
      section-color="pink"
      classes="section flex is-direction:column is-forground"
      :hasCheckers="true"
    >
      <Slider />
    </base-section>

    <section
      class="bkgrd:black section is-padded is-forground"
      ref="hidespinner"
    >
      <TextLists />
      <Bio />
    </section>
  </main>

  <footer class="bkgrd:black text:pink section is-forground">
    <Footer />
  </footer>
</template>

<script>
import StickyMenu from "./components/Sections/StickyMenu.vue";
import Intro from "./components/Sections/Intro.vue";
import FixedBackground from "./components/Sections/FixedBackground.vue";
import Standard from "./components/Sections/Standard.vue";
import ImageCards from "./components/Sections/ImageCards.vue";
import ImageCopy from "./components/Sections/ImageCopy.vue";
import Slider from "./components/UI/Slider.vue";
import TextLists from "./components/Sections/TextLists.vue";
import Bio from "./components/Sections/Bio.vue";
import Footer from "./components/Sections/Footer.vue";

export default {
  components: {
    StickyMenu,
    Intro,
    FixedBackground,
    Standard,
    ImageCards,
    ImageCopy,
    Slider,
    TextLists,
    Bio,
    Footer
  },
  name: "App",
  data() {
    return {
      imageCopy: [
        {
          heading: `<span>
              Nost<span class="-ss02">a</span>lgi<span class="-ss02">a</span> <span class="-ss02">a</span>nd <span class="-ss02">a</span>ttitude
            </span>`,
          copy: `
            M<span class="-ss02">a</span>ples <span class="-ss02">a</span>tt<span class="-ss02">a</span>cks the <span class="-ss02">A</span>merican style of t<span class="-ss02">a</span>ttooing—meshing nost<span class="-ss02">a</span>lgi<span class="-ss02">a</span>, <span class="-ss02">a</span>ttitude <span class="-ss02">a</span>nd rebellion with qu<span class="-ss02">a</span>lity <span class="-ss02">a</span>nd p<span class="-ss02">r</span>eci<span class="-ss02">s</span>ion.
          `,
          image: "am-torsoe-1.jpg",

          name: "Full Torsoe",
          direction: "grid-lr",
          order: "is-order-mobile:2 is-mobile-center"
        },
        {
          heading: `
          Keeping the tr<span class="-ss02">a</span>dition <span class="-ss02">a</span>live
          `,
          copy: `
          <span class="-ss02">A</span>ustin’s work keeps the tr<span class="-ss02">a</span>dition <span class="-ss02">a</span>live while pushing the bound<span class="-ss02">a</span>ries of t<span class="-ss02">a</span>ttooing.
          `,
          image: "am-torsoe-closeup.jpg",
          // icon: "am-mary.svg",
          // iconSize: "icon-small",
          // iconName: "Virgin Mary Icon",
          // iconRight: false,
          name: "Full Torsoe Close Up",
          direction: "grid-rl",
          order: "is-order:2 is-mobile-center",
          position: "is-self:end"
        }
      ],
      showSpinner: { display: null },
      cryingfaceStrength: null,
      cryingfaceOrigin: null
    };
  },
  created() {
    window.addEventListener("scroll", this.onScroll);
    window.addEventListener("resize", () => {
      this.handleParallax();
    });
    window.addEventListener("load", () => {
      this.handleParallax();
    });
  },
  beforeUnmount() {
    window.removeEventListener("scroll", this.onScroll);
    window.removeEventListener("resize", () => {
      this.handleParallax();
    });
    window.removeEventListener("load", () => {
      this.handleParallax();
    });
  },
  mounted() {
    this.handleParallax();
  },
  methods: {
    handleParallax() {
      const win_width = document.body.clientWidth;
      if (win_width >= 1024) {
        this.cryingfaceStrength = 100;
        this.cryingfaceOrigin = 10;
      } else if (win_width < 1024 && win_width >= 600) {
        this.cryingfaceStrength = 120;
        this.cryingfaceOrigin = -10;
      }
    },
    getImage(path) {
      return require(`@/assets/img/${path}`);
    },

    onScroll() {
      if (
        this.$refs.hidespinner.getBoundingClientRect().top <=
        this.$refs.spinner.getBoundingClientRect().top
      ) {
        this.showSpinner.display = "none";
      } else {
        this.showSpinner.display = "block";
      }
    }
  }
};
</script>
<style lang="scss">
@import "~@/assets/scss/config/_variables.scss";
#app {
  // font-family: "Lucifer", sans-serif;
  width: 100vw;
  // max-width: 1680px;
  margin: 0 auto;
  display: flex;
  flex-direction: column;
  min-height: 100vh;
  position: relative;
  // overflow-x: hidden;
  // @media all and (min-width: 1024px) {
  //   overflow-x: auto;
  // }
  // background: black;
  // z-index: 2;
}
header {
  width: 100%;
  margin: 0 auto;
  position: absolute;
  top: 0;
  left: auto;
  right: 0;
  // bottom: 0;

  pointer-events: none;
  z-index: 50;
}
main {
  flex: 1 0 auto;
  margin-bottom: -1px;
  overflow: hidden;
  @media all and (min-width: 1024px) {
    overflow-x: auto;
    margin-bottom: 0;
  }
  // @media all and (min-width: 1024px) {
  // }
}
footer {
  flex-shrink: 0;
  @media all and (min-width: 1120px) {
    padding-top: 9.5rem;
  }
}
.sticky {
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  @media all and (min-width: 768px) {
    position: fixed;
  }
  @media all and (min-width: $intro-mobilebreak) {
    left: auto;
  }
}

.icon-cryingface {
  display: none;
  justify-content: center;
  align-items: center;
  @media all and (min-width: 600px) {
    display: flex;
    img {
      max-width: 5.5rem;
    }
  }
  @media all and (min-width: 1020px) {
    padding-top: 4.65rem;
    padding-bottom: 4.65rem;
    img {
      max-width: 6.37rem;
    }
  }
  @media all and (min-width: 1920px) {
    img {
      max-width: 8.52rem;
    }
  }
}
</style>
